<div class="container">
	<div class="col-sm-12" style="margin-bottom: 20px;">
		<h1>Angular 2 Grid Demo</h1>
		<p>This is a simple demo used for creation/testing of <a href="https://github.com/BTMorton/angular2-grid">angular2-grid</a>, a grid-based drag/drop/resize plugin directive for <a href="http://angular.io">Angular 2</a>. It makes use of angular directives so that in order to include it, all you need to do is add an "[ngGrid]" attribute to your container and an "[ngGridItem]" to each of your grid items. It even works with the ngFor directive to add boxes on the fly!</p>
		<br />
		<form>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Fix to Grid
					</label>
					<input type="checkbox" name="fix_to_grid" ngControl="fix_to_grid" [(ngModel)]="gridConfig.fix_to_grid" />
				</div>
				<div class="form-group">
					<label>
						Draggable
					</label>
					<input type="checkbox" name="draggable" ngControl="draggable" [(ngModel)]="gridConfig.draggable" />
				</div>
				<div class="form-group">
					<label>
						Resizable
					</label>
					<input type="checkbox" name="resizable" ngControl="resizable" [(ngModel)]="gridConfig.resizable" />
				</div>
				<div class="form-group">
					<label>
						Auto-Resize Rows/Columns
					</label>
					<input type="checkbox" name="auto_resize" ngControl="auto_resize" [(ngModel)]="gridConfig.auto_resize" />
				</div>
				<div class="form-group">
					<label>
						Cascade Direction
					</label>
					<select name="cascade" ngControl="cascade" [(ngModel)]="gridConfig.cascade">
						<option value="">Off</option>
						<option value="up">Up</option>
						<option value="down">Down</option>
						<option value="left">Left</option>
						<option value="right">Right</option>
					</select>
				</div>
			</div>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Column Width
						<input type="number" class="form-control" name="col_width" ngControl="col_width" [(ngModel)]="gridConfig.col_width" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Row Height
						<input type="number" class="form-control" name="row_height" ngControl="row_height" [(ngModel)]="gridConfig.row_height" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Margins
						<input type="number" class="form-control" name="margins" ngControl="margins" [(ngModel)]="gridConfig.margins[0]" />
					</label>
				</div>
			</div>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Minimum Column Width
						<input type="number" class="form-control" name="min_width" ngControl="min_width" [(ngModel)]="gridConfig.min_width" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Minimum Row Height
						<input type="number" class="form-control" name="min_height" ngControl="min_height" [(ngModel)]="gridConfig.min_height" />
					</label>
				</div>
			</div>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Max Columns
						<input type="number" class="form-control" name="max_cols" ngControl="max_cols" [(ngModel)]="gridConfig.max_cols" [disabled]="gridConfig.max_rows > 0" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Max Rows
						<input type="number" class="form-control" name="max_rows" ngControl="max_rows" [(ngModel)]="gridConfig.max_rows"  [disabled]="gridConfig.max_cols > 0" />
					</label>
				</div>
			</div>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Visible Columns
						<input type="number" class="form-control" name="visible_cols" ngControl="visible_cols" [(ngModel)]="gridConfig.visible_cols" [disabled]="gridConfig.max_cols > 0 || gridConfig.maintain_ratio" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Visible Rows
						<input type="number" class="form-control" name="visible_rows" ngControl="visible_rows" [(ngModel)]="gridConfig.visible_rows"  [disabled]="gridConfig.max_rows > 0 || gridConfig.maintain_ratio" />
					</label>
				</div>
			</div>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Maintain Aspect Ratio
						<input type="checkbox" class="form-control" name="maintain_ratio" ngControl="maintain_ratio" [(ngModel)]="gridConfig.maintain_ratio" [disabled]="ratioDisabled" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Prefer New Items
						<input type="checkbox" class="form-control" name="prefer_new" ngControl="prefer_new" [(ngModel)]="gridConfig.prefer_new" />
					</label>
				</div>
			</div>
			<div class="form-inline">
				<div class="form-group">
					<label>
						Min Columns
						<input type="number" class="form-control" name="min_cols" ngControl="min_cols" [(ngModel)]="gridConfig.min_cols" />
					</label>
				</div>
				<div class="form-group">
					<label>
						Min Rows
						<input type="number" class="form-control" name="min_rows" ngControl="min_rows" [(ngModel)]="gridConfig.min_rows"  />
					</label>
				</div>
			</div>
			<div class="form-inline">
				<label>
					Get Item Position &amp; Size
					<select name="itemCheck" class="form-control" ngControl="item_check" [(ngModel)]="itemCheck">
						<option *ngFor="let box of boxes; let i = index" [attr.value]="i">{{box.id}}</option>
					</select>
				</label>
				
				Col: {{ curItem.col }}, Row: {{ curItem.row }}, Size X: {{ curItem.sizex }}, Size Y: {{ curItem.sizey }}
				<a (click)="removeBox()" class="btn btn-primary">Remove Box</a>
			</div>
		</form>
		
		<a (click)="_randomise()" class="btn btn-primary pull-right">Randomise Boxes</a>
		<a (click)="addBox()" class="btn btn-primary pull-right">Add Box</a>
	</div>
</div>
<div [ngGrid]="gridConfig">
	<div *ngFor="let box of boxes; let i = index" [(ngGridItem)]="box.config" (itemChange)="updateItem(i, $event)" (resize)="onResize(i, $event)" (drag)="onDrag(i, $event)">
		<div class="handle"></div>
		{{box.id}}
	</div>
	<div [ngGridItem]="{'dragHandle': '.handle', 'fixed': true, 'col': 2, 'row': 3}" (itemChange)="updateItem(i, $event)" (resize)="onResize(i, $event)" (drag)="onDrag(i, $event)">
		<div class="handle"></div>
		Fixed - moveable, resizable
	</div>
	<div [ngGridItem]="{'dragHandle': '.handle', 'fixed': true, 'draggable': false, 'col': 1, 'row': 5}" (itemChange)="updateItem(i, $event)" (resize)="onResize(i, $event)" (drag)="onDrag(i, $event)">
		<div class="handle"></div>
		Fixed - not moveable, resizable
	</div>
	<div [ngGridItem]="{'dragHandle': '.handle', 'fixed': true, 'resizable': false, 'col': 5, 'row': 2}" (itemChange)="updateItem(i, $event)" (resize)="onResize(i, $event)" (drag)="onDrag(i, $event)">
		<div class="handle"></div>
		Fixed - moveable, not resizable
	</div>
	<div [ngGridItem]="{'dragHandle': '.handle', 'fixed': true, 'resizable': false, 'draggable': false, 'col': 3, 'row': 4}" (itemChange)="updateItem(i, $event)" (resize)="onResize(i, $event)" (drag)="onDrag(i, $event)">
		<div class="handle"></div>
		Fixed - not moveable, not resizable
	</div>
</div>